import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrClassservermap {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  ClassId!: IType<number, bigint>;
  ServerId!: IType<number, bigint>;
  ExpireDate?: Date;
  Status!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const IcrClassservermapSchema = defineEntity({
  class: IcrClassservermap,
  comment: '班级和服务器的关系',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级id'),
    ServerId: p.bigint().name('ServerId').columnType('bigint').comment('服务器id'),
    ExpireDate: p.datetime().name('ExpireDate').length(3).nullable().comment('过期时间(天)'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
